var createBrandableArrow = function() {
	var color = 'gray';
	//Length and thickness should be even numbers
	var ARROW_LENGTH = 12;
	var ARROW_THICKNESS = 4;

	var ROTATION_DEGREES = 45;

	var container = Ti.UI.createView({
		height : 2 * ARROW_LENGTH,
		width : 2 * ARROW_LENGTH,
		//touchTestId: touchTestId
	});

	var topLine = Ti.UI.createView({
		height : ARROW_THICKNESS,
		width : ARROW_LENGTH,
		backgroundColor : color,
		top : ARROW_LENGTH / 2
	});

	var bottomLine = Ti.UI.createView({
		height : ARROW_THICKNESS,
		width : ARROW_LENGTH,
		backgroundColor : color,
		top : (ARROW_LENGTH / 2 + ARROW_THICKNESS / 2) + topLine.top - (ARROW_THICKNESS / 2)
	});

	topLine.transform = Ti.UI.create2DMatrix().rotate(ROTATION_DEGREES);
	bottomLine.transform = Ti.UI.create2DMatrix().rotate(-ROTATION_DEGREES);

	container.add(topLine);
	container.add(bottomLine);

	return container;
};

var MapModule = require('ti.map');

var win = Ti.UI.createWindow({
	backgroundColor : 'white'
});

var vert = Ti.UI.createScrollView({
	contentHeight : 'auto',
	scrollType : 'vertical',
	showVerticalScrollIndicator : true,
	layout : 'vertical',
	canCancelEvents : false,
	width : Ti.UI.SIZE
});

var anno1 = MapModule.createAnnotation({
	latitude : -32.87365,
	//image : 'map_pin.png',
	longitude : 151.20689,
	title : "Sydney",
	subtitle : "Sydney is quite chill",
	draggable : true
});
var anno2 = MapModule.createAnnotation({
	latitude : -33.86365,
	pincolor : MapModule.ANNOTATION_BLUE,
	longitude : 151.21689,
	title : "Anno2",
	subtitle : "This is anno2",
	draggable : true,
	image : 'KS_nav_ui.png'
});
var anno3 = MapModule.createAnnotation({
	latitude : -33.85365,
	longitude : 151.20689,
	title : "Anno3",
	subtitle : "This is anno3",
	draggable : false,
	image : 'mbanking/images/Locations-Pin-Android-red-hdpi.png'
});
var anno4 = MapModule.createAnnotation({
	latitude : -33.86365,
	longitude : 151.22689,
	title : "Anno4",
	subtitle : "This is anno4",
	draggable : true,
	pincolor : MapModule.ANNOTATION_BLUE
});
var annotationObject = MapModule.createAnnotation({
	latitude : -33.87365, //data.lat,
	longitude : 151.20689, //data.lon,
	title : 'data.name',
	subtitle : 'this.getAddressString(data)',
	animate : true,
	//rightButton: Ti.UI.iPhone.SystemButton.DISCLOSURE,
	image : 'locations-android-popover-arrow.png', //'/images/android-location-pin-red.png';
	//rightButton: rightView
	//id: data.id,
	//touchTestId: Util.getTouchTestId(targetId, "RedPin", Util.ANNOTATION_TYPE, index)
});

var mapview = MapModule.createView({
	annotations : [anno1, /*anno2, anno3, anno4,*/annotationObject],
	height : 600,
	mapType : MapModule.NORMAL_TYPE,
	region : {
		latitude : -33.87365,
		longitude : 151.20689,
		latitudeDelta : 0.1,
		longitudeDelta : 0.1
	},
});

var rightView = Ti.UI.createView({
	height : Ti.UI.SIZE,
	width : Ti.UI.SIZE,
	backgroundColor : 'transparent'	
});

rightView.add(createBrandableArrow());
/*
rightView.add(
	Ti.UI.createImageView({
			image : 'locations-android-popover-arrow.png',
			width : 25,
			height : 25,
			top : 0,
			right : 0
		})
);
*/
annotationObject.rightButton = rightView;

win.add(mapview);

win.open(); 





/*
var MapModule = require('ti.map');
var win = Ti.UI.createWindow({
	backgroundColor : 'white'
});
var appc = MapModule.createAnnotation({
	latitude : 37.389569,
	longitude : -122.050212,
	title : 'Appcelerator HQ',
	subtitle : 'Mountain View, CA',
	pincolor : MapModule.ANNOTATION_GREEN,
	draggable : true
});
var mapview = MapModule.createView({
	mapType : MapModule.HYBRID_TYPE,
	region : {
		latitude : 37.389569,
		longitude : -122.050212,
		latitudeDelta : 0.2,
		longitudeDelta : 0.2
	},
	annotations : [appc]
});
mapview.addEventListener('pinchangedragstate', function(e) {
	Ti.API.info(e.type);
	Ti.API.info(JSON.stringify(e.newState));
});

mapview.addEventListener('click', function(e) {
	Ti.API.info(e.type);
	Ti.API.info(JSON.stringify(e.clicksource));
});

mapview.addEventListener('regionchanged', function(e) {
	Ti.API.info(e.type);
	Ti.API.info(e.latitude + "," + e.longitude);
});

mapview.addEventListener('complete', function(e) {
	Ti.API.info(e.type);
});

win.add(mapview);
win.open(); 
*/

/*
var MapModule = require('ti.map');

var win = Ti.UI.createWindow({
	fullscreen : false
});
var anno = MapModule.createAnnotation({
	latitude : -33.87365,
	image : 'KS_nav_ui.png',
	longitude : 151.20689,
	title : "Drag Me",
	subtitle : "Sydney is quite chill",
	draggable : true
});
var anno2 = MapModule.createAnnotation({
	latitude : -33.86365,
	pincolor : MapModule.ANNOTATION_BLUE,
	longitude : 151.21689,
	title : "Drag Me 2",
	subtitle : "This is anno2",
	draggable : true
});
var anno3 = MapModule.createAnnotation({
	latitude : -33.85365,
	longitude : 151.20689,
	title : "anno3",
	subtitle : "This is anno3",
	draggable : false
});

var map = MapModule.createView({
	userLocation : true,
	mapType : MapModule.NORMAL_TYPE,
	animate : true,
	annotations : [anno, anno2, anno3],
	region : {
		latitude : -33.87365,
		longitude : 151.20689,
		latitudeDelta : 0.1,
		longitudeDelta : 0.1
	}, //Sydney
	top : '30%'
});

map.addEventListener('click', function(e) {
	var alert = Ti.UI.createAlertDialog({
		title : 'Clicked!',
		message : 'e.annotation.id: ' + e.annotation.id + "e.annotation.index: " + e.annotation.index
	});
	Ti.API.info("Annotation " + e.title);
	alert.show();
});

win.add(map);
win.open(); 
*/

/*

var MapModule = require('ti.map');

var code = MapModule.isGooglePlayServicesAvailable();

if (code != MapModule.SUCCESS) {
	alert("Google Play Services is not installed/updated/available");
} else {
	var win = Ti.UI.createWindow();
	var table = Ti.UI.createTableView();
	var tableData = [];

	var multiMapRow = Ti.UI.createTableViewRow({
		title : 'Multi Map'
	});
	tableData.push(multiMapRow);
	multiMapRow.addEventListener('click', function(e) {
		multiMapTest();
	});

	var annotationRow = Ti.UI.createTableViewRow({
		title : 'AnnotationTest'
	});
	tableData.push(annotationRow);
	annotationRow.addEventListener('click', function(e) {
		annotationTest();
	});

	var routeRow = Ti.UI.createTableViewRow({
		title : 'Routes Test'
	});
	tableData.push(routeRow);
	routeRow.addEventListener('click', function(e) {
		routeTest();
	});

	table.setData(tableData);
	win.add(table);
	win.open();
}

//Multi Maps
function multiMapTest() {
	var win = Ti.UI.createWindow({
		fullscreen : false
	});

	var map1 = MapModule.createView({
		userLocation : true,
		mapType : MapModule.NORMAL_TYPE,
		animate : true,
		region : {
			latitude : -33.87365,
			longitude : 151.20689,
			latitudeDelta : 0.1,
			longitudeDelta : 0.1
		}, //Sydney
		height : '50%',
		top : 0,
		left : 0,
		width : '50%'
	});
	var map2 = MapModule.createView({
		userLocation : true,
		mapType : MapModule.NORMAL_TYPE,
		animate : true,
		region : {
			latitude : -33.87365,
			longitude : 151.20689,
			latitudeDelta : 0.1,
			longitudeDelta : 0.1
		}, //Sydney
		height : '50%',
		top : 0,
		right : 0,
		width : '50%'
	});
	var map3 = MapModule.createView({
		userLocation : true,
		mapType : MapModule.NORMAL_TYPE,
		animate : true,
		region : {
			latitude : -33.87365,
			longitude : 151.20689,
			latitudeDelta : 0.1,
			longitudeDelta : 0.1
		}, //Sydney
		height : '50%',
		bottom : 0,
		left : 0,
		width : '50%'
	});
	var map4 = MapModule.createView({
		userLocation : true,
		mapType : MapModule.NORMAL_TYPE,
		animate : true,
		region : {
			latitude : -33.87365,
			longitude : 151.20689,
			latitudeDelta : 0.1,
			longitudeDelta : 0.1
		}, //Sydney
		height : '50%',
		bottom : 0,
		right : 0,
		width : '50%'
	});

	win.add(map1);
	win.add(map2);
	win.add(map3);
	win.add(map4);
	win.open();
}

//ANNOTATIONS
function annotationTest() {
	var win = Ti.UI.createWindow({
		fullscreen : false
	});
	var anno = MapModule.createAnnotation({
		latitude : -33.87365,
		image : 'map_pin.png',
		longitude : 151.20689,
		title : "Sydney",
		subtitle : "Sydney is quite chill",
		draggable : true
	});
	var anno2 = MapModule.createAnnotation({
		latitude : -33.86365,
		pincolor : MapModule.ANNOTATION_BLUE,
		longitude : 151.21689,
		title : "Anno2",
		subtitle : "This is anno2",
		draggable : true
	});
	var anno3 = MapModule.createAnnotation({
		latitude : -33.85365,
		longitude : 151.20689,
		title : "Anno3",
		subtitle : "This is anno3",
		draggable : false
	});
	var anno4 = MapModule.createAnnotation({
		latitude : -33.86365,
		longitude : 151.22689,
		title : "Anno4",
		subtitle : "This is anno4",
		draggable : true
	});

	Ti.API.info("Latitude:" + anno.latitude);
	Ti.API.info("Title:" + anno.title);

	var map = MapModule.createView({
		userLocation : true,
		mapType : MapModule.NORMAL_TYPE,
		animate : true,
		annotations : [anno, anno2, anno4],
		region : {
			latitude : -33.87365,
			longitude : 151.20689,
			latitudeDelta : 0.1,
			longitudeDelta : 0.1
		}, //Sydney
		top : '30%'
	});
	Ti.API.info("userLocation: " + map.userLocation);
	win.add(map);

	map.addEventListener('click', function(e) {
		Ti.API.info("Latitude: " + e.latitude);
		Ti.API.info("Source: " + e.clicksource);
	});
	var button = Ti.UI.createButton({
		top : 0,
		left : 0,
		title : "Go Mt. View"
	});
	button.addEventListener('click', function(e) {
		map.region = {
			latitude : 37.3689,
			longitude : -122.0353,
			latitudeDelta : 0.1,
			longitudeDelta : 0.1
		};
		//Mountain View
	});

	var button2 = Ti.UI.createButton({
		top : 0,
		right : 0,
		title : "add anno3"
	});
	button2.addEventListener('click', function(e) {
		map.addAnnotation(anno3);
	});

	var button3 = Ti.UI.createButton({
		top : 0,
		title : "rm anno3"
	});
	button3.addEventListener('click', function(e) {
		map.removeAnnotation(anno3);
	});

	var button4 = Ti.UI.createButton({
		top : '10%',
		title : "rm all"
	});
	button4.addEventListener('click', function(e) {
		map.removeAllAnnotations();
	});

	var button5 = Ti.UI.createButton({
		top : '10%',
		left : 0,
		title : "remove annos"
	});
	button5.addEventListener('click', function(e) {
		Ti.API.info(anno.getTitle());
		map.removeAnnotations(["Sydney", anno2]);
	});

	var button6 = Ti.UI.createButton({
		top : '10%',
		right : 0,
		title : "select anno2"
	});
	button6.addEventListener('click', function(e) {
		map.selectAnnotation(anno2);
	});

	var button7 = Ti.UI.createButton({
		top : '20%',
		left : 0,
		title : "desel anno2"
	});
	button7.addEventListener('click', function(e) {
		map.deselectAnnotation(anno2);
	});

	var button8 = Ti.UI.createButton({
		top : '20%',
		right : 0,
		title : "modify anno2"
	});
	button8.addEventListener('click', function(e) {
		anno2.title = "Hello";
		anno2.subtitle = "Hi there.";
		anno2.longitude = 151.27689;
	});

	win.add(button);
	win.add(button2);
	win.add(button3);
	win.add(button4);
	win.add(button5);
	win.add(button6);
	win.add(button7);
	win.add(button8);
	win.open();
}

//Routes
function routeTest() {

	var win = Ti.UI.createWindow({
		fullscreen : false
	});
	var map = MapModule.createView({
		userLocation : true,
		mapType : MapModule.NORMAL_TYPE,
		animate : true,
		region : {
			latitude : -33.87365,
			longitude : 151.20689,
			latitudeDelta : 0.02,
			longitudeDelta : 0.02
		}, //Sydney
		top : '30%'
	});
	win.add(map);

	var route1 = [{
		latitude : -33.87365,
		longitude : 151.20689
	}, {
		latitude : -33.87469,
		longitude : 151.20689
	}, {
		latitude : -33.87375,
		longitude : 151.20589
	}];
	var route2 = [{
		latitude : -33.87565,
		longitude : 151.20789
	}, {
		latitude : -33.87469,
		longitude : 151.20689
	}, {
		latitude : -33.86375,
		longitude : 151.20589
	}];

	var route = MapModule.createRoute({
		points : route1,
		color : "blue",
		width : 5.0
	});

	map.addRoute(route);

	var button = Ti.UI.createButton({
		top : 0,
		left : 0,
		title : "+1 width"
	});
	var w = 5.0;
	button.addEventListener('click', function(e) {
		route.width = w + 1.0;
		w = w + 1.0;
	});

	var button2 = Ti.UI.createButton({
		top : 0,
		title : "change color"
	});
	button2.addEventListener('click', function(e) {
		route.color = 'red';
	});

	var button3 = Ti.UI.createButton({
		top : 0,
		right : 0,
		title : "change routes"
	});
	button3.addEventListener('click', function(e) {
		route.points = route2;
	});

	var button4 = Ti.UI.createButton({
		top : '10%',
		title : "remove route"
	});
	button4.addEventListener('click', function(e) {
		map.removeRoute(route);
	});

	var button5 = Ti.UI.createButton({
		top : '10%',
		left : 0,
		title : "add route"
	});
	button5.addEventListener('click', function(e) {
		map.addRoute(route);
	});

	win.add(button);
	win.add(button2);
	win.add(button3);
	win.add(button4);
	win.add(button5);
	win.open();
}


*/



//For FR, run the above test case. Should see a blue dot showing the user's current location and
//the my-location button in the top right corner of the map. 
//Click the two buttons to toggle "userLocation" and "userLocationButton". 
//Note: the my-location button only shows when userLocation==true && userLocationButton==true.

/*
 * Single Window Application Template:
 * A basic starting point for your application.  Mostly a blank canvas.
 * 
 * In app.js, we generally take care of a few things:
 * - Bootstrap the application with any data we need
 * - Check for dependencies like device type, platform version or network connection
 * - Require and open our top-level UI component
 *  
 */

/*bootstrap and check dependencies
if (Ti.version < 1.8) {
	alert('Sorry - this application template requires Titanium Mobile SDK 1.8 or later');
}

// This is a single context application with mutliple windows in a stack
(function() {
	//determine platform and form factor and render approproate components
	var osname = Ti.Platform.osname, version = Ti.Platform.version, height = Ti.Platform.displayCaps.platformHeight, width = Ti.Platform.displayCaps.platformWidth;

	//considering tablet to have one dimension over 900px - this is imperfect, so you should feel free to decide
	//yourself what you consider a tablet form factor for android
	var isTablet = osname === 'ipad' || (osname === 'android' && (width > 899 || height > 899));

	var Window;
	if (isTablet) {
		Window = require('ui/tablet/ApplicationWindow');
	} else {
		// Android uses platform-specific properties to create windows.
		// All other platforms follow a similar UI pattern.
		if (osname === 'android') {
			Window = require('ui/handheld/android/ApplicationWindow');
		} else {
			Window = require('ui/handheld/ApplicationWindow');
		}
	}
	new Window().open();

	var data = [{
		title : "Row 1"
	}, {
		title : "Row 2"
	}, {
		title : "Row 3"
	}];
	var tableView = Ti.UI.createTableView({
		data : data
	});

})();
*/



